import pygame
from . import const

def get_tile_at_xy(level, x, y):
    return (int((x - const.MAP_OFFSET_X) / level.tile_size), int((y - const.MAP_OFFSET_Y) / level.tile_size))

def get_xy_at_tile(level, x, y):
    return (x * level.tile_size + const.MAP_OFFSET_X, y * level.tile_size + const.MAP_OFFSET_Y)

def get_target_tilepos(level, tilepos, dir):
    target_tilepos = [tilepos[0] + dir[0], tilepos[1] + dir[1]]
    looped_tilepos = list(tilepos)
    if target_tilepos[0] >= level.width:
        target_tilepos[0] = 0
        looped_tilepos[0] = -1
    if target_tilepos[0] < 0:
        target_tilepos[0] = level.width - 1
        looped_tilepos[0] = level.width
    if target_tilepos[1] >= level.height:
        target_tilepos[1] = 0
        looped_tilepos[1] = -1
    if target_tilepos[1] < 0:
        target_tilepos[1] = level.height - 1
        looped_tilepos[1] = level.height
    return tuple(target_tilepos), tuple(looped_tilepos)